<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning . 'admin_api/global_settings/template/template_function.php';
//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    //   !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
    !isset($postdata['class_id']) or !checkIfIssetAndNotEmpty($postdata['class_id']) or
    !isset($postdata['section_id']) or !checkIfIssetAndNotEmpty($postdata['section_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning,$conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

$class_id = trim($postdata['class_id']);
$section_id = ($postdata['section_id']);

$function_type = trim($postdata['function_type']);

function getStudentsCards($conn_rjllearning,$conn_rjllearning_specific, $institution_id, $userid, $function_type, $search_string, $branch_id, $class_id, $section_id, $limit, $offset)
{
    $Faculty_Codes = $conn_rjllearning_specific->prepare("SELECT id FROM faculty_info WHERE userid = ? AND institution_id = ? AND branch_id = ?");
    $Faculty_Codes->execute(array($userid, $institution_id, $branch_id));

    // Fetch a single row instead of all
    $result_faculty = $Faculty_Codes->fetch(PDO::FETCH_ASSOC);

    // Check if the faculty exists
    if ($result_faculty === false) {
        errorreturn("Faculty Not Found.");
    }

    // Retrieve the faculty_id from the result
    $faculty_id = $result_faculty['id'];
    $teacher_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);
    $class_section_subjects  = $teacher_data['class_section_subjects'];
    $class_incharge_roles = $teacher_data['class_incharge_roles'];
    $staff_access_modules = $teacher_data['staff_access_modules'];

    $check_faculty_status = checkFacultyModuleGranted($function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules, $class_id, $section_id, null, $conn_rjllearning);

    if($check_faculty_status == false){
        errorreturn("Access denied: You do not have the required permissions.");
    }
    
    $sql = "SELECT  count(*) as total_rows FROM  student_id_cards  where institution_id =?";
    $array_params = array($institution_id);
    
    $sql_append_data = facultyFilterQueryAppend($sql, $array_params, $function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules,$class_id, $section_id, null,$conn_rjllearning, 1, 1, 1, 1);

    // Get the modified SQL and merged array of parameters
    $sql_marksheet_info = $sql_append_data['sql'];  // Get the modified SQL query
    $array_params =  $sql_append_data['array_params']; 

    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {

        $sql = "SELECT * FROM  student_id_cards  where institution_id =?";
        $array_params = [$institution_id];
        if ($branch_id == 'all') {
            $sql .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }

        if ($class_id == 'all') {
            $sql .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql .= " AND class_id = ? ";
            $array_params[] = $class_id;
        }
        if ($section_id == 'all') {
            $sql .= "";
        } else if ($section_id !=  null  and $section_id != 'all') {

            $sql .= " AND section_id = ? ";
            $array_params[] = $section_id;
        }
      
      $sql .=  "order by date_created desc";
        
        
    } else {
        $sql = "SELECT * FROM student_id_cards WHERE institution_id = ?";
        $array_params = [$institution_id];
        
        if ($branch_id == 'all') {
            $sql .= "";
        } else if ($branch_id !=  null  && $branch_id != 'all') {
            $sql .= " AND branch_id = ? ";
            $array_params[] = $branch_id;
        }

        if ($class_id == 'all') {
            $sql .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql .= " AND class_id = ? ";
            $array_params[] = $class_id;
        }

        if ($section_id == 'all') {
            $sql .= "";
        } else if ($section_id !=  null  and $section_id != 'all') {
            $sql .= " AND section_id = ? ";
            $array_params[] = $section_id;
        }
    
      $sql .= " order by date_created desc, generated_on desc ";
      $sql .= "LIMIT " . $offset . " ," . $limit . "";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();


    $array_return = [];

    foreach ($result as $rows) {
        
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['class_id']);
        $section_info = getSection($conn_rjllearning_specific, $institution_id, $rows['section_id']);
        $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        $student_id = $rows['student_id'];

        $students = []; // Initialize branches array

        if ($student_id == 'all') {

            $students[] = array('student_id' => $student_id, 'name' => ucwords($student_id));
        } else {
            // $imploded_branchids = implode(',', $branch_id); // Convert array to comma-separated string
            // print_R($imploded_branchids);
            $sql = "SELECT * FROM students WHERE institution_id = ? AND id IN ($student_id) ";
            $array_params = [$institution_id]; // Add institution_id to parameters
            $stmt = $conn_rjllearning_specific->prepare($sql);
            $stmt->execute($array_params);
            $student_results = $stmt->fetchAll();

            foreach ($student_results as $data) {
                $students[] = array('student_id' => $data['id'], 'name' => $data['name']);
            }
        }   
       
        $data_printed[] = json_decode($rows['data_printed'], true);
        $template_info = getSpecificPrintTemplate($conn_rjllearning,$rows['selected_template']);
      
        $array_return[] = array('cards_id'=> $rows['id'],'branch_id'=>$branch_info ,'class_id'=> $class_info,'section_id'=> $section_info,
        'student_id'=> $students,'selected_template'=>$template_info , 'data_printed' => $data_printed);
    }

    if (count($result) < 50) {
        return array('total_rows' => $totalrows, 'cards_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'cards_info' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_student_cards") {
    // $institution_id = trim($postdata['institution_id']);
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    // if(isset($postdata['branch_id']) and !empty($postdata['branch_id']) and trim($postdata['branch_id'])) {
    //     $branch_id = trim($postdata['branch_id']);
    // } else {
    //     $branch_id = null;
    // }
    
    if (isset($postdata['class_id']) and !empty($postdata['class_id']) and trim($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = "all";
    }
    
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    if (isset($postdata['section_id']) and !empty($postdata['section_id']) and trim($postdata['section_id'])) {
        $section_id = trim($postdata['section_id']);
    } else {
        $section_id = "all";
    }

    $limit = $postdata['limit'];
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getStudentsCards($conn_rjllearning,$conn_rjllearning_specific, $institution_id, $userid, $function_type, $search_string, $branch_id, $class_id, $section_id, $limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getStudentsCards($conn_rjllearning,$conn_rjllearning_specific, $institution_id, $userid, $function_type, $search_string, $branch_id, $class_id, $section_id, $limit, null);
        successreturn($success);
    }
}
